# Installation

The instructions below will help you to properly installand run the generated package to the lavalite project.

## Location

Extract the package contents to the folder 

`/packages/emerald/the_art_of_ethical_hacking...../`

## Composer

Add the below entries in the `composer.json`.


```json

...
     "repositories": {
        ...

        {
            "type": "path",
            "url": "packages/emerald/the_art_of_ethical_hacking....."
        }

        ...
    },
...

```
Then run `composer require emerald/the_art_of_ethical_hacking.....`


## Migration and seeds

```
    php artisan migrate
    php artisan db:seed --class=Emerald\\TheArtOfEthicalHacking.....\\Seeders\\TheArtOfEthicalHacking.....TableSeeder
```

## Publishing

* Configuration
```
    php artisan vendor:publish --provider="Emerald\TheArtOfEthicalHacking.....\Providers\TheArtOfEthicalHacking.....ServiceProvider" --tag="config"
```
* Language
```
    php artisan vendor:publish --provider="Emerald\TheArtOfEthicalHacking.....\Providers\TheArtOfEthicalHacking.....ServiceProvider" --tag="lang"
```
* Views
```
    php artisan vendor:publish --provider="Emerald\TheArtOfEthicalHacking.....\Providers\TheArtOfEthicalHacking.....ServiceProvider" --tag="view"
```

## URLs and APIs

### Web Urls

* Admin
```
    http://path-to-route-folder/admin/the_art_of_ethical_hacking...../{modulename}
```

* User
```
    http://path-to-route-folder/user/the_art_of_ethical_hacking...../{modulename}
```

* Public
```
    http://path-to-route-folder/the_art_of_ethical_hacking.....s
```


### API endpoints

These endpoints can be used with or without `/api/`
And also the user can be varied depend on the type of users, eg user, client, admin etc.

#### Resource

* List
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}
    METHOD: GET
```

* Create
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}
    METHOD: POST
```

* Edit
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/{id}
    METHOD: PUT
```

* Delete
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/{id}
    METHOD: DELETE
```

#### Public

* List
```
    http://path-to-route-folder/api/the_art_of_ethical_hacking...../{modulename}
    METHOD: GET
```

* Single Item
```
    http://path-to-route-folder/api/the_art_of_ethical_hacking...../{modulename}/{slug}
    METHOD: GET
```

#### Others

* Report
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/report/{report}
    METHOD: GET
```

* Export/Import
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/exim/{exim}
    METHOD: POST
```

* Action
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/action/{id}/{action}
    METHOD: PATCH
```

* Actions
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/actions/{action}
    METHOD: PATCH
```

* Workflow
```
    http://path-to-route-folder/api/user/the_art_of_ethical_hacking...../{modulename}/workflow/{id}/{transition}
    METHOD: PATCH
```
